<?php
namespace Teknisa\EST\Modules\EstoqueCego\Controllers;

use Teknisa\EST\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use \Teknisa\Libs\Util\DateUtil;

class Est94000AprovacaoInventarioCegoController extends TeknisaCrud {

    protected $dataSourceName = "";
    protected $parameterBagColumns = [];
    protected $dataSourceManager;
    protected $environment;
    protected $crudService;
    
    public function __construct($crudService, $parameterBag, $dataSourceManager, $environment) {

        $this->crudService = $crudService;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
    }
    
    public function changeInventorySituation(Request $request, Response $response) {
        try {
            $rows = $request->getDataSet()->getRows();
            $params = $request->getParameters();
            
            foreach($rows as $row){
                $row['IDSITESTCEGO'] =  $params['situation'] == 'approved' ? "AP" : "ED";
                
                $datetime = DateUtil::getDataAtual();
                $row['DTAPROVINVESTCE'] = $row['IDSITESTCEGO'] == 'AP' ? $datetime->format("d/m/Y H:i:s") : $row['DTAPROVINVESTCE'] = null ;
            };
            
            $datasetToSave = new DataSet('inventestcego', $rows);
            $requestToSave = new DTO\Request\DataSet($datasetToSave, '', '', '');
            $rowsToSave = $this->crudService->getRowsToSave($requestToSave, "inventestcego");
            $dataSetToSave = new DataSet("inventestcego", $rowsToSave);
            $this->dataSourceManager->persist($dataSetToSave);
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}

